//! @file conf_usb.h,v
//!
//! Copyright (c) 2006 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂłB
//!
//! ̧قUSB̉\ȊO`Ԑݒ܂݂܂B
//!
//! @version 1.1 at90usb128-demo-touchscreen-1_0_0 $Id: conf_usb.h,v 1.1 2006/03/14 12:25:22 rletendu Exp $
//!
//! @todo
//! @bug
#ifndef _CONF_USB_H_
#define _CONF_USB_H_

//! @defgroup usb_general_conf USBp`Ԑݒ
//!
//! @{

  // _________________ USB`Ԑݒ ________________________________________
  //
  //! @defgroup USB_op_mode USB`Ԑݒ
  //! pɂĎx鑕u܂νĂ̓`Ԃ̋`܂B
  //! @{

	//! @brief ν ĳ ײ؎xɂɂENABLE
	//!
	//! \ȒlENABLE܂DISABLE
	#define USB_HOST_FEATURE		DISABLED

	//! @brief uĳ ײ؎xɂɂENABLE
	//!
	//! \ȒlENABLE܂DISABLE
	#define USB_DEVICE_FEATURE		ENABLED
  //! @}

  // _________________ USB`Ԑݒ _____________________________________
  //
  //! @defgroup USB_reg_mode USB`Ԑݒ
  //! @{

  //! @brief USB߯ޗp
  //!
  //! pd3.5VႢɓd͏œK̂߁AUSB߯ޒ
  //! ~邱Ƃł܂B
#ifndef USE_USB_PADS_REGULATOR
  #define USE_USB_PADS_REGULATOR	ENABLE		// \ȒlENABLE܂DISABLE
#endif
  //! @}

  // _________________ νē`Ԑݒ ________________________________________
  //
  //! @defgroup USB_host_mode_cfg USBνē`Ԑݒ
  //!
  //! @{

  #define HID_CLASS					0x03
  #define MS_CLASS					0x08

  //! @brief VID/PIDx\ꗗ
  //!
  //! ̕\͍팸νĉpɂĎxVID/PID܂݂܂B
  //! VID_PID_TABLE``:
  //!
  //! #define VID_PID_TABLE		{VID1, number_of_pid_for_this_VID1, PID11_value,..., PID1X_Value \n
  //!							...\n
  //!							,VIDz, number_of_pid_for_this_VIDz, PIDz1_value,..., PIDzX_Value}
  #define VID_PID_TABLE			{0x03EB, 2, 0x201C, 0x2014 \
							    ,0x0123, 3, 0x2000, 0x2100, 0x1258}

  //! @brief CLASS/SUBCLASS_PROTOCOLx\ꗗ
  //!
  //! ̕\͍팸νĉpɂĎxCLASS/SUBCLASS/PROTOCOL܂݂܂B
  //! ̕\`͒PVID/PID\ꗗɑClass/subclass/protocolŜx
  //! 팸půg܂B
  //!
  //! CLASS_SUBCLASS_PROTOCOL``: \n
  //! #define CLASS_SUBCLASS_PROTOCOL	{CLASS1, SUB_CLASS1,PROTOCOL1, \n
  //!									...\n
  //!									CLASSz, SUB_CLASSz,PROTOCOLz}
  #define CLASS_SUBCLASS_PROTOCOL		{0x0A, 0x00, 0x00, \
										 0x00, 0x00, 0x00,\
										 0xFF, 0x00, 0x00}

  //! Lqqɗ\񂳂ꂽRAMɏՕ̗e
  #define SIZEOF_DATA_STAGE					250

  //! ڑuɊ蓖Ăڽ
  #define DEVICE_ADDRESS					0x05

  //! νĐVID/PIDꗗŐ܂B
  //! AuPID/VIDxꗗɂȂȂAνĐײ؂͂[`
  //! ݒł͂ȂُԂ֍s܂B
  #define HOST_STRICT_VID_PID_TABLE			DISABLE

  //! MuLqqɏ]ν ߲ߌ`Ԑݒs
  #define HOST_AUTO_CFG_ENDPOINT			ENABLE

  //! ν ڰъJn荞ݏ펞
  #define HOST_CONTINUOUS_SOF_INTERRUPT		DISABLE

  //! νĈُԌoAڑԂɍs
  #define HOST_ERROR_RESTART				ENABLE

  //! IDݕωWDTؾċ
  #define ID_PIN_CHANGE_GENERATE_RESET		DISABLE

  //! ԒߑO1/4b(250ms)NAK޼
  #define NAK_TIMEOUT_DELAY					1

  #if (HOST_AUTO_CFG_ENDPOINT==FALSE)
	//! ߲Ă̎`ԐݒłȂ΁AɎgpҊ֐zu
	#define User_configure_endpoint()
  #endif

  //! @defgroup host_cst_actions USBνēƎ
  //!
  //! @{
  // eUSBνĎۂɊ֘A銈ɏĂB
  // ֐𗐂ɏԂQȂ悤ɒӂĂB
  #define Usb_id_transition_action()
  #define Host_device_disconnection_action()
  #define Host_device_connection_action()
  #define Host_sof_action()
  #define Host_suspend_action()				host_suspend_action();
  #define Host_hwup_action()
  #define Host_device_not_supported_action()
  #define Host_device_supported_action()
  #define Host_device_error_action()
  //! @}

extern void host_suspend_action (void);
  //! @}

// _________________ u`Ԑݒ _________________________________________

  //! @defgroup USB_device_mode_cfg USBu`Ԑݒ
  //!
  //! @{

#define NB_ENDPOINTS			2			//! ߲Ă܂މpł̴߲Đ
#define EP_TOUCHSCREEN_IN		1			//! ڐGʊ荞IN߲Đ

#define Usb_unicode(a)			((U16)(a))

  //! @defgroup device_cst_actions USBuƎ
  //!
  //! @{
  // eUSBνĎۂɊ֘A銈ɏĂB
  // ֐𗐂ɏԂQȂ悤ɒӂĂB
#define Usb_sof_action()		sof_action();
#define Usb_wake_up_action()
#define Usb_resume_action()
#define Usb_suspend_action()	suspend_action();
#define Usb_reset_action()
#define Usb_vbus_on_action()
#define Usb_vbus_off_action()	vbus_off_action();
#define Usb_set_configuration_action()
  //! @}

extern void sof_action (void);
extern void suspend_action (void);
extern void vbus_off_action (void);
  //! @}
//! @}

#endif // _CONF_USB_H_
