/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: TWI_Slave.c
* ߲		: IAR EWAAVR 2.28a/3.10c
* 			: $Revision: 1.7 $
* t			: $Date: Thursday, August 05, 2004 09:22:50 UTC $
* XV		: $Author: lholsen $
*
* xҰ		: avr@atmel.com
*
* x޲	: gp\TWIS޲
*				  (ATmega16pɏĂ܂B)
*
* pLq		: AVR311 - TWI]u
*
* 			: AVRTWIɑ΂鎎ײނłB
*				  ͊荞݋쓮łBSĂ̋@\͊֐Ƃ̏nʂ
*				  Đ䂳܂Bײގgp@̗main.cB
*
****************************************************************************/
#include "touchscreen_task.h"
 
static unsigned char TWI_buf[TWI_BUFFER_SIZE];		// TWIMɏՕ(ͯ ̧قŗeʂݒ肵ĂB)
static unsigned char TWI_msgSize  = 0;				// M޲Đ
static unsigned char TWI_state    = TWI_NO_STATE;	// TWI޲(TWI_NO_STATE)

union TWI_statusReg TWI_statusReg = {0};			// ׸(TWI_statusRegTWI_Slave.hŒ`Ă܂B)

/****************************************************************************
TWI]ȕҋ@Ԃɐݒ肷ɂ͂̊֐ĂłBTWI
Ɏ剞pŊ荞݂邱ƂYȂłB]uڽƈČĂяo
ł̋NKv̗𓯂޲ēœnĂB̊֐ĂяoɗႦ
΂̕\L@gpĂB
TWI_Slave_Initialize((TWI_slaveAddress<<TWI_ADR_| (TRUE<<TWI_GEN_BIT));
TWI͂ǂ̗vɉĂNACKɌ`Ԑݒ肳܂BTWIJnɂ
TWI_ Start_Transceiver֐gpĂB
****************************************************************************/
void TWI_Slave_Initialise( unsigned char TWI_ownAddress )
{
  TWAR = TWI_ownAddress;					// g̏]uڽݒAČĂяo/֎~ݒ
  TWDR = 0xFF;								// ްl(SDAJɂ܂B)
  TWCR = (1<<TWEN)|							// TWI
		 (0<<TWIE)|(0<<TWINT)|				// TWI荞݋֎~
		 (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|	// TWI޽J(NACK)
		 (0<<TWWC);							//
}

/****************************************************************************
TWI荞ݏٰ݂]Z𒲂ׂɂ͂̊֐ĂłB
****************************************************************************/
unsigned char TWI_Transceiver_Busy( void )
{
  return ( TWCR & (1<<TWIE) );							// TWIZ׸ނƋɕA
}

/****************************************************************************
Ȍԏ擾ɂ͂̊֐ĂłB֐TWI荞ݏ
ٰ݂O܂ŎsT܂(ҋ@)Bُ킪ꍇA֐
TWIԕԂ܂B
****************************************************************************/
unsigned char TWI_Get_State_Info( void )
{
  while ( TWI_Transceiver_Busy() );			// TWI]܂őҋ@
  return ( TWI_state );						// TWIԕƋɕA
}

/****************************************************************************
\ߗpӂꂽүނ𑗂A܂͎MpɑMnɂ͂̊֐Ă
łBSLA+WMꂽɑׂްւ߲܂߂ĂBް
TWIޯ̧ɕʂ܂B޲Ăׂ܂߂ĂB呕u֐Ɠ
lł͂ȂAڽ ޲Ăү ޯ̧Ɋ܂߂ȂƂɒӂĂB֐
TWI荞ݏٰ݂OAĎ̑Ė߂܂Ŏs
T܂(ҋ@)B
****************************************************************************/
void TWI_Start_Transceiver_With_Data( unsigned char *msg, unsigned char msgSize )
{
  unsigned char temp;

  while ( TWI_Transceiver_Busy() );			// TWI܂őҋ@

  TWI_msgSize = msgSize;					// M޲Đ(ۑ)
  for ( temp = 0; temp < msgSize; temp++ )	// 呕uvɑMްgޯ̧֕
	TWI_buf[ temp ] = msg[ temp ];
  TWI_statusReg.all = 0;					// S׸ޏ((0))
  TWI_state         = TWI_NO_STATE ;		// TWIԂȂԂɐݒ
  TWCR = (1<<TWEN)|							// TWI
		 (1<<TWIE)|(1<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
		 (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|	// 񂩂ACKw
		 (0<<TWWC);							//
}

/****************************************************************************
VKMް̎wȂɑMnɂ͂̊֐ĂłBM
JA܂͎MpɂMn̂ɗLpłBײނ͒OɑMޯ
̧ɒuꂽްĎgp܂B֐TWI荞ݏٰ݂OA
Ď̑Ė߂܂ŎsT܂(ҋ@)B
****************************************************************************/
void TWI_Start_Transceiver( void )
{
  while ( TWI_Transceiver_Busy() );			// TWI܂őҋ@
  TWI_statusReg.all = 0;					// S׸ޏ((0))
  TWI_state         = TWI_NO_STATE ;		// TWIԂȂԂɐݒ
  TWCR = (1<<TWEN)|							// TWI
		 (1<<TWIE)|(1<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
		 (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|	// 񂩂ACKw
		 (0<<TWWC);							//
}
/****************************************************************************
TWIMޯ̧Mްǂݏoɂ͂̊֐ĂłB
ƁATWIMް擾邽߁AŏTWI_Start_Transceiver֐Ă
łBĂ炪ް擾߂ɂ̊֐𑖂点Ă
B֐Ăяoɉްuꏊւ߲Ǝ擾޲Đ܂߂Ă
B֐ްǂݏoĖ߂OɁATWI荞ݏٰ݂O
ŎsT܂(ҋ@)Bُ킪ꍇA֐TWIԕԂ܂B
****************************************************************************/
unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
{
  unsigned char i;

  while ( TWI_Transceiver_Busy() );			// TWI܂őҋ@

  if( TWI_statusReg.lastTransOK )			// ŏI]ŁA
  {
	for ( i=0; i<msgSize; i++ )				// Mޯ̧牞pޯ̧֓e
	{
	  msg[ i ] = TWI_buf[ i ];
	}
	TWI_statusReg.RxDataInBuf = FALSE;		// MްL׸މ(0)
  }
  return( TWI_statusReg.lastTransOK );		// L/׸ނƋɕA
}

// * 荞ݏٰ *
/****************************************************************************
̊֐͊荞ݏٰ(ISR)ŁATWIۂNɕKNTWI荞
ݎɎIɌĂ΂܂B̊֐͎剞p璼ڌĂ΂ׂł͂܂B
****************************************************************************/
#pragma vector=TWI_vect
__interrupt void TWI_ISR( void )
{
  static unsigned char TWI_bufPtr;

  switch (TWSR)
  {
	case TWI_STX_ADR_ACK:				// SLA+RM,ACKԓ
//	case TWI_STX_ADR_ACK_M_ARB_LOST:	// 呕uƂSLA+R/WŒs,SLA+RM,ACKԓ
	  TWI_bufPtr   = 0;							// Mޯ̧ʒuwq
	case TWI_STX_DATA_ACK:				// ްM,ACKM
	  TWDR = TWI_buf[TWI_bufPtr++];				// ްݒ
	  TWCR = (1<<TWEN)|							// TWI
			 (1<<TWIE)|(1<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
			 (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|	// ACKw(p)
			 (0<<TWWC);							//
	  break;
	case TWI_STX_DATA_NACK:				// ްM,NACKM(ƁA呕uvI)
	  if (TWI_bufPtr == TWI_msgSize)		// ]ʈvŁA
	  {
		TWI_statusReg.lastTransOK = TRUE;		// ]׸ސݒ(1)
	  }else									// ]ʕsv(Ⴆ΁AcLŎ呕ȗł؂)ŁA
	  {
		TWI_state = TWSR;						// ُԂƂTWIԕݒ
	  }
	  TWCR = (1<<TWEN)|							// TWI
			 (0<<TWIE)|(0<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
			 (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|	// ڽvACKw
			 (0<<TWWC);							//
	  break;
	case TWI_SRX_GEN_ACK:				// ČĂяoM,ACKԓ
//	case TWI_SRX_GEN_ACK_M_ARB_LOST:	// 呕uƂSLA+R/WŒs,ČĂяoM,ACKԓ
	  TWI_statusReg.genAddressCall = TRUE;		// ČĂяo׸ސݒ(1)
	case TWI_SRX_ADR_ACK:				// SLA+WM,ACKԓ
//	case TWI_SRX_ADR_ACK_M_ARB_LOST:	// 呕uƂSLA+R/WŒs,SLA+WM,ACKԓ
										// (TWI_S_statusRegister.generalAddressCall0̂߉͕sv)
	  TWI_statusReg.RxDataInBuf = TRUE;			// MްL׸ސݒ(1)
	  // () ̎_ł׸ސݒ͎ްȂ̏ԂłB݂͌̎Ml
	  //		擾ٰ݂ł͖ɂȂ܂񂪁A炩̕ύXꍇɖ
	  //		邩܂B̏ꍇ͂ł͂ȂAްM׸
	  //		ݒ肵ĂB
	  TWI_bufPtr   = 0;							// TWIMޯ̧ʒuwq
	  TWCR = (1<<TWEN)|							// TWI
			 (1<<TWIE)|(1<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
			 (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|	// ]ACKw
			 (0<<TWWC);							//
	  break;
	case TWI_SRX_ADR_DATA_ACK:			// SLA+Ww蒆ްM,ACKԓ
	case TWI_SRX_GEN_DATA_ACK:			// ČĂяoްM,ACKԓ
	  TWI_buf[TWI_bufPtr++]     = TWDR;			// MްlTWIMޯ̧Ɋi[
	  TWI_statusReg.lastTransOK = TRUE;			// (޲)]׸ސݒ(1)
	  TWCR = (1<<TWEN)|							// TWI
			 (1<<TWIE)|(1<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
			 (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|	// ]ACKw
			 (0<<TWWC);							//
	  break;
	case TWI_SRX_STOP_RESTART:			// ]uƂıڽw蒆ɒ~܂͍đJno
	  TWCR = (1<<TWEN)|							// TWI
			 (0<<TWIE)|(0<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
			 (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|	// ڽvACKw
			 (0<<TWWC);							//
	  break;
	case TWI_SRX_ADR_DATA_NACK:			// SLA+Ww蒆ްM,NACKԓ
	case TWI_SRX_GEN_DATA_NACK:			// ČĂяoްM,NACKԓ
	case TWI_STX_DATA_ACK_LAST_BYTE:	// ŏIްM(TWA=0),ACKM
//	case TWI_NO_STATE					// p\Ȋ֘A󋵏Ȃ
	case TWI_BUS_ERROR:					// s@ȊJn܂͒~̂߂޽ُ
	default:
	  TWI_state = TWSR;							// ُƂTWIԕݒ
	  // (STWIԕ̉ʑ3ޯĂ0Ȃ̂ŁAKRIɑS׸ނ(0)܂B)
	  TWCR = (1<<TWEN)|							// TWI
			 (0<<TWIE)|(0<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
			 (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|	// ]ACKw
			 (0<<TWWC);							//
  }
}

unsigned char TWI_Act_On_Failure_In_Last_Transmission ( unsigned char TWIerrorMsg )
{
  // sAs̎ނ߂̂TWIerrorMsgpēK؂ȓ
  // BL蓾鎸sүނ̈ꗗɂĂͯ ̧قB

  // ̔ɊȒPȗُ͈필߰BɒuAMɏՕ̓ްőM
  // Ďn܂B
  PORTB = TWIerrorMsg;
  TWI_Start_Transceiver();
  return TWIerrorMsg; 
}
